diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1t.h openssl-1.0.0q/crypto/asn1/asn1t.h
--- openssl-1.0.0q.orig/crypto/asn1/asn1t.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1t.h	2017-04-25 16:23:39.883530446 +0200
@@ -795,33 +1320,47 @@
 		(ASN1_d2i_func *)d2i_##sname, \
 		(ASN1_i2d_func *)i2d_##sname, \
 	}; \
-	ASN1_ITEM_start(sname) \
+	ASN1_ITEM_TEMPLATE_BLOCK(sname, \
 		ASN1_ITYPE_COMPAT, \
 		tag, \
 		NULL, \
 		0, \
 		&sname##_ff, \
-		0, \
-		#sname \
-	ASN1_ITEM_end(sname)
+		0)
 
 #define IMPLEMENT_EXTERN_ASN1(sname, tag, fptrs) \
-	ASN1_ITEM_start(sname) \
+	ASN1_ITEM_TEMPLATE_BLOCK(sname,\
 		ASN1_ITYPE_EXTERN, \
 		tag, \
 		NULL, \
 		0, \
 		&fptrs, \
-		0, \
-		#sname \
-	ASN1_ITEM_end(sname)
+		0)
 
 /* Macro to implement standard functions in terms of ASN1_ITEM structures */
 
 #define IMPLEMENT_ASN1_FUNCTIONS(stname) IMPLEMENT_ASN1_FUNCTIONS_fname(stname, stname, stname)
 
+#define IMPLEMENT_ASN1_FUNCTIONS1(stname) IMPLEMENT_ASN1_FUNCTIONS_fname1(stname, stname, stname)
+#define IMPLEMENT_ASN1_FUNCTIONS11(stname) IMPLEMENT_ASN1_FUNCTIONS_fname11(stname, stname, stname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS2(stname) IMPLEMENT_ASN1_FUNCTIONS_fname2(stname, stname, stname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS3(stname) IMPLEMENT_ASN1_FUNCTIONS_fname3(stname, stname, stname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS31(stname) IMPLEMENT_ASN1_FUNCTIONS_fname31(stname, stname, stname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS32(stname) IMPLEMENT_ASN1_FUNCTIONS_fname32(stname, stname, stname)
+
 #define IMPLEMENT_ASN1_FUNCTIONS_name(stname, itname) IMPLEMENT_ASN1_FUNCTIONS_fname(stname, itname, itname)
 
+#define IMPLEMENT_ASN1_FUNCTIONS_name1(stname, itname) IMPLEMENT_ASN1_FUNCTIONS_fname1(stname, itname, itname)
+#define IMPLEMENT_ASN1_FUNCTIONS_name11(stname, itname) IMPLEMENT_ASN1_FUNCTIONS_fname11(stname, itname, itname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_name2(stname, itname) IMPLEMENT_ASN1_FUNCTIONS_fname2(stname, itname, itname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_name3(stname, itname) IMPLEMENT_ASN1_FUNCTIONS_fname3(stname, itname, itname)
+
 #define IMPLEMENT_ASN1_FUNCTIONS_ENCODE_name(stname, itname) \
 			IMPLEMENT_ASN1_FUNCTIONS_ENCODE_fname(stname, itname, itname)
 
@@ -831,6 +1370,12 @@
 #define IMPLEMENT_ASN1_ALLOC_FUNCTIONS(stname) \
 		IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname(stname, stname, stname)
 
+#define IMPLEMENT_ASN1_ALLOC_FUNCTIONS1(stname) \
+		IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname1(stname, stname, stname)
+
+#define IMPLEMENT_ASN1_ALLOC_FUNCTIONS2(stname) \
+		IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname2(stname, stname, stname)
+
 #define IMPLEMENT_ASN1_ALLOC_FUNCTIONS_pfname(pre, stname, itname, fname) \
 	pre stname *fname##_new(void) \
 	{ \
@@ -851,10 +1396,42 @@
 		ASN1_item_free((ASN1_VALUE *)a, ASN1_ITEM_rptr(itname)); \
 	}
 
+#define IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname1(stname, itname, fname) \
+	stname *fname##_new(void) \
+	{ \
+		return (stname *)ASN1_item_new(ASN1_ITEM_rptr(itname)); \
+	}
+
+#define IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname2(stname, itname, fname) \
+	void fname##_free(stname *a) \
+	{ \
+		ASN1_item_free((ASN1_VALUE *)a, ASN1_ITEM_rptr(itname)); \
+	}
+
 #define IMPLEMENT_ASN1_FUNCTIONS_fname(stname, itname, fname) \
 	IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname(stname, itname, fname) \
 	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname(stname, itname, fname)
 
+#define IMPLEMENT_ASN1_FUNCTIONS_fname1(stname, itname, fname) \
+	IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname1(stname, itname, fname) \
+	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname(stname, itname, fname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_fname11(stname, itname, fname) \
+	IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname1(stname, itname, fname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_fname2(stname, itname, fname) \
+	IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname2(stname, itname, fname) \
+	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname(stname, itname, fname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_fname3(stname, itname, fname) \
+	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname(stname, itname, fname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_fname31(stname, itname, fname) \
+	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname1(stname, itname, fname)
+
+#define IMPLEMENT_ASN1_FUNCTIONS_fname32(stname, itname, fname) \
+	IMPLEMENT_ASN1_ALLOC_FUNCTIONS_fname2(stname, itname, fname)
+
 #define IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname(stname, itname, fname) \
 	stname *d2i_##fname(stname **a, const unsigned char **in, long len) \
 	{ \
@@ -865,6 +1442,18 @@
 		return ASN1_item_i2d((ASN1_VALUE *)a, out, ASN1_ITEM_rptr(itname));\
 	} 
 
+#define IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname1(stname, itname, fname) \
+	int i2d_##fname(stname *a, unsigned char **out) \
+	{ \
+		return ASN1_item_i2d((ASN1_VALUE *)a, out, ASN1_ITEM_rptr(itname));\
+	}
+
+#define IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname2(stname, itname, fname) \
+	stname *d2i_##fname(stname **a, const unsigned char **in, long len) \
+	{ \
+		return (stname *)ASN1_item_d2i((ASN1_VALUE **)a, in, len, ASN1_ITEM_rptr(itname));\
+	}
+
 #define IMPLEMENT_ASN1_NDEF_FUNCTION(stname) \
 	int i2d_##stname##_NDEF(stname *a, unsigned char **out) \
 	{ \
@@ -884,10 +1473,23 @@
 		return ASN1_item_i2d((ASN1_VALUE *)a, out, ASN1_ITEM_rptr(itname));\
 	} 
 
+#define IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname1(stname, itname, fname) \
+	stname *d2i_##fname(stname **a, const unsigned char **in, long len) \
+	{ \
+		return (stname *)ASN1_item_d2i((ASN1_VALUE **)a, in, len, ASN1_ITEM_rptr(itname));\
+	}
+
+#define IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname2(stname, itname, fname) \
+	int i2d_##fname(const stname *a, unsigned char **out) \
+	{ \
+		return ASN1_item_i2d((ASN1_VALUE *)a, out, ASN1_ITEM_rptr(itname));\
+	}
+
+
 #define IMPLEMENT_ASN1_DUP_FUNCTION(stname) \
 	stname * stname##_dup(stname *x) \
         { \
-        return ASN1_item_dup(ASN1_ITEM_rptr(stname), x); \
+        return (stname *) ASN1_item_dup(ASN1_ITEM_rptr(stname), x); \
         }
 
 #define IMPLEMENT_ASN1_PRINT_FUNCTION(stname) \
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn_moid.c openssl-1.0.0q/crypto/asn1/asn_moid.c
--- openssl-1.0.0q.orig/crypto/asn1/asn_moid.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn_moid.c	2017-04-25 16:23:39.886529151 +0200
@@ -56,10 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include <ctype.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
-#include "cryptlib.h"
 #include <openssl/conf.h>
 #include <openssl/dso.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn_pack.c openssl-1.0.0q/crypto/asn1/asn_pack.c
--- openssl-1.0.0q.orig/crypto/asn1/asn_pack.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn_pack.c	2017-04-25 16:23:39.889528694 +0200
@@ -56,8 +56,10 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 
 #ifndef NO_ASN1_OLD
@@ -66,6 +68,7 @@
 
 /* Turn an ASN1 encoded SEQUENCE OF into a STACK of structures */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 STACK_OF(OPENSSL_BLOCK) *ASN1_seq_unpack(const unsigned char *buf, int len,
 			 d2i_of_void *d2i, void (*free_func)(OPENSSL_BLOCK))
 {
@@ -92,7 +95,7 @@
 		ASN1err(ASN1_F_ASN1_SEQ_PACK,ASN1_R_ENCODE_ERROR);
 		return NULL;
 	}
-	if (!(safe = OPENSSL_malloc (safelen))) {
+	if (!(safe = (unsigned char *) OPENSSL_malloc (safelen))) {
 		ASN1err(ASN1_F_ASN1_SEQ_PACK,ERR_R_MALLOC_FAILURE);
 		return NULL;
 	}
@@ -103,9 +106,11 @@
 	if (buf) *buf = safe;
 	return safe;
 }
+#endif // LIBOPEAY_PKCS12_SUPPORT
 
 /* Extract an ASN1 object from an ASN1_STRING */
 
+#ifndef OPERA_SMALL_VERSION
 void *ASN1_unpack_string(ASN1_STRING *oct, d2i_of_void *d2i)
 {
 	const unsigned char *p;
@@ -116,16 +121,18 @@
 		ASN1err(ASN1_F_ASN1_UNPACK_STRING,ASN1_R_DECODE_ERROR);
 	return ret;
 }
+#endif /* !OPERA_SMALL_VERSION */
 
 /* Pack an ASN1 object into an ASN1_STRING */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 ASN1_STRING *ASN1_pack_string(void *obj, i2d_of_void *i2d, ASN1_STRING **oct)
 {
 	unsigned char *p;
-	ASN1_STRING *octmp;
+	ASN1_STRING *octmp, *ocalloc=NULL;
 
 	if (!oct || !*oct) {
-		if (!(octmp = ASN1_STRING_new ())) {
+		if (!(ocalloc = octmp = ASN1_STRING_new ())) {
 			ASN1err(ASN1_F_ASN1_PACK_STRING,ERR_R_MALLOC_FAILURE);
 			return NULL;
 		}
@@ -133,12 +140,18 @@
 	} else octmp = *oct;
 		
 	if (!(octmp->length = i2d(obj, NULL))) {
+		if(ocalloc && !oct)
+			ASN1_STRING_free(ocalloc);
 		ASN1err(ASN1_F_ASN1_PACK_STRING,ASN1_R_ENCODE_ERROR);
-		goto err;
+// GAB		goto err;
+ 		return NULL;
 	}
-	if (!(p = OPENSSL_malloc (octmp->length))) {
+	if (!(p = (unsigned char *) OPENSSL_malloc (octmp->length))) {
+		if(ocalloc && !oct)
+			ASN1_STRING_free(ocalloc);
 		ASN1err(ASN1_F_ASN1_PACK_STRING,ERR_R_MALLOC_FAILURE);
-		goto err;
+// GAB		goto err;
+		return NULL;
 	}
 	octmp->data = p;
 	i2d (obj, &p);
@@ -152,11 +165,13 @@
 		}
 	return NULL;
 }
+#endif // LIBOPEAY_PKCS12_SUPPORT
 
 #endif
 
 /* ASN1_ITEM versions of the above */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 ASN1_STRING *ASN1_item_pack(void *obj, const ASN1_ITEM *it, ASN1_STRING **oct)
 {
 	ASN1_STRING *octmp;
@@ -174,7 +189,7 @@
 		octmp->data = NULL;
 	}
 		
-	if (!(octmp->length = ASN1_item_i2d(obj, &octmp->data, it))) {
+	if (!(octmp->length = ASN1_item_i2d((ASN1_VALUE *) obj, &octmp->data, it))) {
 		ASN1err(ASN1_F_ASN1_ITEM_PACK,ASN1_R_ENCODE_ERROR);
 		return NULL;
 	}
@@ -184,6 +199,7 @@
 	}
 	return octmp;
 }
+#endif // LIBOPEAY_PKCS12_SUPPORT
 
 /* Extract an ASN1 object from an ASN1_STRING */
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/d2i_pr.c openssl-1.0.0q/crypto/asn1/d2i_pr.c
--- openssl-1.0.0q.orig/crypto/asn1/d2i_pr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/d2i_pr.c	2017-04-25 16:23:39.891529227 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/d2i_pu.c openssl-1.0.0q/crypto/asn1/d2i_pu.c
--- openssl-1.0.0q.orig/crypto/asn1/d2i_pu.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/d2i_pu.c	2017-04-25 16:23:39.893530599 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/evp_asn1.c openssl-1.0.0q/crypto/asn1/evp_asn1.c
--- openssl-1.0.0q.orig/crypto/asn1/evp_asn1.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/evp_asn1.c	2017-04-25 16:23:39.895529736 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1_mac.h>
 
@@ -93,10 +96,11 @@
 		num=ret;
 	else
 		num=max_len;
-	memcpy(data,p,num);
+	op_memcpy(data,p,num);
 	return(ret);
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int ASN1_TYPE_set_int_octetstring(ASN1_TYPE *a, long num, unsigned char *data,
 	     int len)
 	{
@@ -135,6 +139,7 @@
 	ASN1_TYPE_set(a,V_ASN1_SEQUENCE,osp);
 	return(1);
 	}
+#endif
 
 /* we return the actual length..., num may be missing, in which
  * case, set it to zero */
@@ -180,7 +185,7 @@
 		n=max_len;
 
 	if (data != NULL)
-		memcpy(data,M_ASN1_STRING_data(os),n);
+		op_memcpy(data,M_ASN1_STRING_data(os),n);
 	if (0)
 		{
 err:
diff -Naur openssl-1.0.0q.orig/crypto/asn1/f_enum.c openssl-1.0.0q/crypto/asn1/f_enum.c
--- openssl-1.0.0q.orig/crypto/asn1/f_enum.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/f_enum.c	2017-04-25 16:23:39.897529711 +0200
@@ -56,7 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
@@ -66,7 +71,7 @@
 int i2a_ASN1_ENUMERATED(BIO *bp, ASN1_ENUMERATED *a)
 	{
 	int i,n=0;
-	static const char *h="0123456789ABCDEF";
+	const char * const h="0123456789ABCDEF";
 	char buf[2];
 
 	if (a == NULL) return(0);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/f_int.c openssl-1.0.0q/crypto/asn1/f_int.c
--- openssl-1.0.0q.orig/crypto/asn1/f_int.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/f_int.c	2017-04-25 16:23:39.899529127 +0200
@@ -56,15 +56,20 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
 
 int i2a_ASN1_INTEGER(BIO *bp, ASN1_INTEGER *a)
 	{
 	int i,n=0;
-	static const char *h="0123456789ABCDEF";
+	const char * const h="0123456789ABCDEF";
 	char buf[2];
 
 	if (a == NULL) return(0);
@@ -131,9 +136,9 @@
 			/* This #ifdef is not strictly necessary, since
 			 * the characters A...F a...f 0...9 are contiguous
 			 * (yes, even in EBCDIC - but not the whole alphabet).
-			 * Nevertheless, isxdigit() is faster.
+			 * Nevertheless, op_isxdigit() is faster.
 			 */
-			if (!isxdigit(buf[j]))
+			if (!op_isxdigit(buf[j]))
 #endif
 				{
 				i=j;
@@ -169,7 +174,7 @@
 				sp=(unsigned char *)OPENSSL_malloc(
 					(unsigned int)num+i*2);
 			else
-				sp=OPENSSL_realloc_clean(s,slen,num+i*2);
+				sp= (unsigned char *) OPENSSL_realloc_clean(s,slen,num+i*2);
 			if (sp == NULL)
 				{
 				ASN1err(ASN1_F_A2I_ASN1_INTEGER,ERR_R_MALLOC_FAILURE);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/f_string.c openssl-1.0.0q/crypto/asn1/f_string.c
--- openssl-1.0.0q.orig/crypto/asn1/f_string.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/f_string.c	2017-04-25 16:23:39.902528670 +0200
@@ -56,15 +56,20 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
 
 int i2a_ASN1_STRING(BIO *bp, ASN1_STRING *a, int type)
 	{
 	int i,n=0;
-	static const char *h="0123456789ABCDEF";
+	const char *const h="0123456789ABCDEF";
 	char buf[2];
 
 	if (a == NULL) return(0);
@@ -131,9 +136,9 @@
 			/* This #ifdef is not strictly necessary, since
 			 * the characters A...F a...f 0...9 are contiguous
 			 * (yes, even in EBCDIC - but not the whole alphabet).
-			 * Nevertheless, isxdigit() is faster.
+			 * Nevertheless, op_isxdigit() is faster.
 			 */
-			if (!isxdigit(buf[j]))
+			if (!op_isxdigit(buf[j]))
 #endif
 				{
 				i=j;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/i2d_pr.c openssl-1.0.0q/crypto/asn1/i2d_pr.c
--- openssl-1.0.0q.orig/crypto/asn1/i2d_pr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/i2d_pr.c	2017-04-25 16:23:39.904529483 +0200
@@ -56,8 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#if defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#include <openssl/bn.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
 #include "asn1_locl.h"
@@ -77,4 +81,5 @@
 	ASN1err(ASN1_F_I2D_PRIVATEKEY,ASN1_R_UNSUPPORTED_PUBLIC_KEY_TYPE);
 	return(-1);
 	}
+#endif // defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/i2d_pu.c openssl-1.0.0q/crypto/asn1/i2d_pu.c
--- openssl-1.0.0q.orig/crypto/asn1/i2d_pu.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/i2d_pu.c	2017-04-25 16:23:39.906529179 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#if defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
@@ -92,4 +95,5 @@
 		return(-1);
 		}
 	}
+#endif // defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/n_pkey.c openssl-1.0.0q/crypto/asn1/n_pkey.c
--- openssl-1.0.0q.orig/crypto/asn1/n_pkey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/n_pkey.c	2017-04-25 16:23:39.908527757 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_RSA
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #ifndef OPENSSL_NO_RSA
 #include <openssl/rsa.h>
 #include <openssl/objects.h>
@@ -87,20 +90,20 @@
 	} NETSCAPE_ENCRYPTED_PKEY;
 
 
-ASN1_BROKEN_SEQUENCE(NETSCAPE_ENCRYPTED_PKEY) = {
-	ASN1_SIMPLE(NETSCAPE_ENCRYPTED_PKEY, os, ASN1_OCTET_STRING),
+ASN1_BROKEN_SEQUENCE(NETSCAPE_ENCRYPTED_PKEY)
+	ASN1_SIMPLE(NETSCAPE_ENCRYPTED_PKEY, os, ASN1_OCTET_STRING)
 	ASN1_SIMPLE(NETSCAPE_ENCRYPTED_PKEY, enckey, X509_SIG)
-} ASN1_BROKEN_SEQUENCE_END(NETSCAPE_ENCRYPTED_PKEY)
+ASN1_BROKEN_SEQUENCE_END(NETSCAPE_ENCRYPTED_PKEY)
 
 DECLARE_ASN1_FUNCTIONS_const(NETSCAPE_ENCRYPTED_PKEY)
 DECLARE_ASN1_ENCODE_FUNCTIONS_const(NETSCAPE_ENCRYPTED_PKEY,NETSCAPE_ENCRYPTED_PKEY)
 IMPLEMENT_ASN1_FUNCTIONS_const(NETSCAPE_ENCRYPTED_PKEY)
 
-ASN1_SEQUENCE(NETSCAPE_PKEY) = {
-	ASN1_SIMPLE(NETSCAPE_PKEY, version, LONG),
-	ASN1_SIMPLE(NETSCAPE_PKEY, algor, X509_ALGOR),
+ASN1_SEQUENCE(NETSCAPE_PKEY)
+	ASN1_SIMPLE(NETSCAPE_PKEY, version, LONG)
+	ASN1_SIMPLE(NETSCAPE_PKEY, algor, X509_ALGOR)
 	ASN1_SIMPLE(NETSCAPE_PKEY, private_key, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(NETSCAPE_PKEY)
+ASN1_SEQUENCE_END(NETSCAPE_PKEY)
 
 DECLARE_ASN1_FUNCTIONS_const(NETSCAPE_PKEY)
 DECLARE_ASN1_ENCODE_FUNCTIONS_const(NETSCAPE_PKEY,NETSCAPE_PKEY)
@@ -203,11 +206,11 @@
 		ASN1err(ASN1_F_I2D_RSA_NET,ASN1_R_BAD_PASSWORD_READ);
 		goto err;
 		}
-	i = strlen((char *)buf);
+	i = op_strlen((char *)buf);
 	/* If the key is used for SGC the algorithm is modified a little. */
 	if(sgckey) {
 		EVP_Digest(buf, i, buf, NULL, EVP_md5(), NULL);
-		memcpy(buf + 16, "SGCKEYSALT", 10);
+		op_memcpy(buf + 16, "SGCKEYSALT", 10);
 		i = 26;
 	}
 
@@ -253,7 +256,7 @@
 		return NULL;
 	}
 
-	if ((enckey->os->length != 11) || (strncmp("private-key",
+	if ((enckey->os->length != 11) || (op_strncmp("private-key",
 		(char *)enckey->os->data,11) != 0))
 		{
 		ASN1err(ASN1_F_D2I_RSA_NET,ASN1_R_PRIVATE_KEY_HEADER_MISSING);
@@ -296,10 +299,10 @@
 		goto err;
 		}
 
-	i = strlen((char *)buf);
+	i = op_strlen((char *)buf);
 	if(sgckey){
 		EVP_Digest(buf, i, buf, NULL, EVP_md5(), NULL);
-		memcpy(buf + 16, "SGCKEYSALT", 10);
+		op_memcpy(buf + 16, "SGCKEYSALT", 10);
 		i = 26;
 	}
 		
diff -Naur openssl-1.0.0q.orig/crypto/asn1/nsseq.c openssl-1.0.0q/crypto/asn1/nsseq.c
--- openssl-1.0.0q.orig/crypto/asn1/nsseq.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/nsseq.c	2017-04-25 16:23:39.910527452 +0200
@@ -56,11 +56,14 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/objects.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int nsseq_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
 							void *exarg)
@@ -75,9 +78,10 @@
 
 /* Netscape certificate sequence structure */
 
-ASN1_SEQUENCE_cb(NETSCAPE_CERT_SEQUENCE, nsseq_cb) = {
-	ASN1_SIMPLE(NETSCAPE_CERT_SEQUENCE, type, ASN1_OBJECT),
+ASN1_SEQUENCE_cb(NETSCAPE_CERT_SEQUENCE, nsseq_cb)
+	ASN1_SIMPLE(NETSCAPE_CERT_SEQUENCE, type, ASN1_OBJECT)
 	ASN1_EXP_SEQUENCE_OF_OPT(NETSCAPE_CERT_SEQUENCE, certs, X509, 0)
-} ASN1_SEQUENCE_END_cb(NETSCAPE_CERT_SEQUENCE, NETSCAPE_CERT_SEQUENCE)
+ASN1_SEQUENCE_END_cb(NETSCAPE_CERT_SEQUENCE, NETSCAPE_CERT_SEQUENCE)
+
+IMPLEMENT_ASN1_FUNCTIONS2(NETSCAPE_CERT_SEQUENCE)
 
-IMPLEMENT_ASN1_FUNCTIONS(NETSCAPE_CERT_SEQUENCE)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/opera_a_bool.cpp openssl-1.0.0q/crypto/asn1/opera_a_bool.cpp
--- openssl-1.0.0q.orig/crypto/asn1/opera_a_bool.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/opera_a_bool.cpp	2017-04-25 16:23:39.913528951 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "a_bool.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/asn1/opera_asn1_par.cpp openssl-1.0.0q/crypto/asn1/opera_asn1_par.cpp
--- openssl-1.0.0q.orig/crypto/asn1/opera_asn1_par.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/opera_asn1_par.cpp	2017-04-25 16:23:39.935526719 +0200
@@ -0,0 +1,16 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2007 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "modules/libopeay/openssl/cryptlib.h"
+#include "modules/libopeay/crypto/asn1/asn1_par.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/asn1/opera_f_int.cpp openssl-1.0.0q/crypto/asn1/opera_f_int.cpp
--- openssl-1.0.0q.orig/crypto/asn1/opera_f_int.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/opera_f_int.cpp	2017-04-25 16:23:39.940528192 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "f_int.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/asn1/opera_f_string.cpp openssl-1.0.0q/crypto/asn1/opera_f_string.cpp
--- openssl-1.0.0q.orig/crypto/asn1/opera_f_string.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/opera_f_string.cpp	2017-04-25 16:23:39.941526643 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "f_string.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/asn1/opera_t_x509a.cpp openssl-1.0.0q/crypto/asn1/opera_t_x509a.cpp
--- openssl-1.0.0q.orig/crypto/asn1/opera_t_x509a.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/opera_t_x509a.cpp	2017-04-25 16:23:39.950527508 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "t_x509a.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/asn1/p5_pbe.c openssl-1.0.0q/crypto/asn1/p5_pbe.c
--- openssl-1.0.0q.orig/crypto/asn1/p5_pbe.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/p5_pbe.c	2017-04-25 16:23:39.978527156 +0200
@@ -56,18 +56,22 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/rand.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* PKCS#5 password based encryption structure */
 
-ASN1_SEQUENCE(PBEPARAM) = {
-	ASN1_SIMPLE(PBEPARAM, salt, ASN1_OCTET_STRING),
+ASN1_SEQUENCE(PBEPARAM)
+	ASN1_SIMPLE(PBEPARAM, salt, ASN1_OCTET_STRING)
 	ASN1_SIMPLE(PBEPARAM, iter, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(PBEPARAM)
+ASN1_SEQUENCE_END(PBEPARAM)
 
 IMPLEMENT_ASN1_FUNCTIONS(PBEPARAM)
 
@@ -103,7 +107,7 @@
 		}
 	sstr = ASN1_STRING_data(pbe->salt);
 	if (salt)
-		memcpy(sstr, salt, saltlen);
+		op_memcpy(sstr, salt, saltlen);
 	else if (RAND_pseudo_bytes(sstr, saltlen) < 0)
 		goto err;
 
@@ -146,3 +150,4 @@
 	X509_ALGOR_free(ret);
 	return NULL;
 	}
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/asn1/p5_pbev2.c openssl-1.0.0q/crypto/asn1/p5_pbev2.c
--- openssl-1.0.0q.orig/crypto/asn1/p5_pbev2.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/p5_pbev2.c	2017-04-25 16:23:39.980527969 +0200
@@ -56,27 +56,31 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/rand.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-/* PKCS#5 v2.0 password based encryption structures */
 
-ASN1_SEQUENCE(PBE2PARAM) = {
-	ASN1_SIMPLE(PBE2PARAM, keyfunc, X509_ALGOR),
+/* PKCS#5 v2.0 password based encryption structures */
+ASN1_SEQUENCE(PBE2PARAM)
+	ASN1_SIMPLE(PBE2PARAM, keyfunc, X509_ALGOR)
 	ASN1_SIMPLE(PBE2PARAM, encryption, X509_ALGOR)
-} ASN1_SEQUENCE_END(PBE2PARAM)
+ASN1_SEQUENCE_END(PBE2PARAM)
 
 IMPLEMENT_ASN1_FUNCTIONS(PBE2PARAM)
 
-ASN1_SEQUENCE(PBKDF2PARAM) = {
-	ASN1_SIMPLE(PBKDF2PARAM, salt, ASN1_ANY),
-	ASN1_SIMPLE(PBKDF2PARAM, iter, ASN1_INTEGER),
-	ASN1_OPT(PBKDF2PARAM, keylength, ASN1_INTEGER),
+ASN1_SEQUENCE(PBKDF2PARAM)
+	ASN1_SIMPLE(PBKDF2PARAM, salt, ASN1_ANY)
+	ASN1_SIMPLE(PBKDF2PARAM, iter, ASN1_INTEGER)
+	ASN1_OPT(PBKDF2PARAM, keylength, ASN1_INTEGER)
 	ASN1_OPT(PBKDF2PARAM, prf, X509_ALGOR)
-} ASN1_SEQUENCE_END(PBKDF2PARAM)
+ASN1_SEQUENCE_END(PBKDF2PARAM)
 
 IMPLEMENT_ASN1_FUNCTIONS(PBKDF2PARAM)
 
@@ -93,7 +97,7 @@
 	X509_ALGOR *scheme = NULL, *kalg = NULL, *ret = NULL;
 	int alg_nid;
 	EVP_CIPHER_CTX ctx;
-	unsigned char iv[EVP_MAX_IV_LENGTH];
+	unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK 2004-02-18 yngve */
 	PBKDF2PARAM *kdf = NULL;
 	PBE2PARAM *pbe2 = NULL;
 	ASN1_OCTET_STRING *osalt = NULL;
@@ -149,9 +153,9 @@
 	if(!(osalt = M_ASN1_OCTET_STRING_new())) goto merr;
 
 	if (!saltlen) saltlen = PKCS5_SALT_LEN;
-	if (!(osalt->data = OPENSSL_malloc (saltlen))) goto merr;
+	if (!(osalt->data = (unsigned char *) OPENSSL_malloc (saltlen))) goto merr;
 	osalt->length = saltlen;
-	if (salt) memcpy (osalt->data, salt, saltlen);
+	if (salt) op_memcpy (osalt->data, salt, saltlen);
 	else if (RAND_pseudo_bytes (osalt->data, saltlen) < 0) goto merr;
 
 	if(iter <= 0) iter = PKCS5_DEFAULT_ITER;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/p8_pkey.c openssl-1.0.0q/crypto/asn1/p8_pkey.c
--- openssl-1.0.0q.orig/crypto/asn1/p8_pkey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/p8_pkey.c	2017-04-25 16:23:39.982526826 +0200
@@ -56,10 +56,14 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Minor tweak to operation: zero private key data */
 static int pkey_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
@@ -75,12 +79,12 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(PKCS8_PRIV_KEY_INFO, pkey_cb) = {
-	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, version, ASN1_INTEGER),
-	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, pkeyalg, X509_ALGOR),
-	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, pkey, ASN1_ANY),
+ASN1_SEQUENCE_cb(PKCS8_PRIV_KEY_INFO, pkey_cb)
+	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, version, ASN1_INTEGER)
+	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, pkeyalg, X509_ALGOR)
+	ASN1_SIMPLE(PKCS8_PRIV_KEY_INFO, pkey, ASN1_ANY)
 	ASN1_IMP_SET_OF_OPT(PKCS8_PRIV_KEY_INFO, attributes, X509_ATTRIBUTE, 0)
-} ASN1_SEQUENCE_END_cb(PKCS8_PRIV_KEY_INFO, PKCS8_PRIV_KEY_INFO)
+ASN1_SEQUENCE_END_cb(PKCS8_PRIV_KEY_INFO, PKCS8_PRIV_KEY_INFO)
 
 IMPLEMENT_ASN1_FUNCTIONS(PKCS8_PRIV_KEY_INFO)
 
@@ -152,4 +156,3 @@
 		*pa = p8->pkeyalg;
 	return 1;
 	}
-
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_bitst.c openssl-1.0.0q/crypto/asn1/t_bitst.c
--- openssl-1.0.0q.orig/crypto/asn1/t_bitst.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_bitst.c	2017-04-25 16:23:39.984528477 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
@@ -95,8 +97,8 @@
 {
 	BIT_STRING_BITNAME *bnam;
 	for(bnam = tbl; bnam->lname; bnam++) {
-		if(!strcmp(bnam->sname, name) ||
-			!strcmp(bnam->lname, name) ) return bnam->bitnum;
+		if(!op_strcmp(bnam->sname, name) ||
+			!op_strcmp(bnam->lname, name) ) return bnam->bitnum;
 	}
 	return -1;
 }
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_crl.c openssl-1.0.0q/crypto/asn1/t_crl.c
--- openssl-1.0.0q.orig/crypto/asn1/t_crl.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_crl.c	2017-04-25 16:23:39.987531373 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/bn.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_pkey.c openssl-1.0.0q/crypto/asn1/t_pkey.c
--- openssl-1.0.0q.orig/crypto/asn1/t_pkey.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_pkey.c	2017-04-25 16:23:39.989529672 +0200
@@ -56,8 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/buffer.h>
 #include <openssl/bn.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_req.c openssl-1.0.0q/crypto/asn1/t_req.c
--- openssl-1.0.0q.orig/crypto/asn1/t_req.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_req.c	2017-04-25 16:23:39.994529469 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/bn.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_spki.c openssl-1.0.0q/crypto/asn1/t_spki.c
--- openssl-1.0.0q.orig/crypto/asn1/t_spki.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_spki.c	2017-04-25 16:23:39.997528733 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
